#include "DigitalPin.h"


//******************************************************************************************************************************************************
//'member' definitions: (here we define the actual c++ code and memory allocation of the members)
//******************************************************************************************************************************************************

DigitalPin::DigitalPin(int pin) //this is the constructor
{
  _pin = pin; //here we store the pin number in the private variable _pin.
}

void DigitalPin::begin() //this initializes the pin
{
  pinMode(_pin, OUTPUT);
}

void DigitalPin::on() //this turns the pin on
{
  digitalWrite(_pin, HIGH);
  _status=1; //set the status property
}

void DigitalPin::off() //this turns the pin off
{
  digitalWrite(_pin, LOW);
  _status=0; //set the status property
}

bool DigitalPin::status() //this returns the current status of the pin.
//It could be used by some other component of the sketch that needs to know whether the pin is on or off.
//This is an example for a method for 'communication' between or with objects.
{
    return _status;
}

